package uloha1;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Node;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.SAXReader;
import org.dom4j.io.XMLWriter;


/*************************************************************************
 *  Tento kod tridy vezmete, doplnte tela metod <code>adjustSalary</code>,
 *  <code>changeName</code> a <code>getWageCosts</code>.
 *  S ostatnimi nedelejte nic.
 *  Po doplneni by mela fungovat metoda <code>main</code> tak, jak je.
 *  Pro preklad a spusteni muzete vyuzit skript build.xml.
 *
 *  Kompletni balicek <code>dom4j</code> stahnete z http://dom4j.org,
 *  zde z duvodu uspory mista najdete jen <code>dom4j.jar</code>,
 *  ktery ale pro preklad i beh staci.
 */
public class Uloha1 {
    
    /**
     * dom4j object model representation of a xml document.
     * Note: We use the interface(!) not its implementation
     */
    private Document doc;
    
    
    /*************************************************************************
     * Metoda na upravu platu.
     * Ma-li osoba mensi plat nez <code>minimum</code>,
     * bude ji plat zvysen na <code>minimum</code>.
     * S ostatnimi osobami se nic nedeje.
     */
    public void adjustSalary(float minimum) {
        // sem doplnte kod metody (misto uvedene vyjimky)
        throw new UnsupportedOperationException();
    }
    
    /*************************************************************************
     * Metoda na zmenu jmena.
     * U osoby s danym <code>id</code> se zmeni jmeno na <code>newName</code>.
     * S ostatnimi osobami se nic nedeje.
     */
    public void changeName(String id, String newName) {
        // sem doplnte kod metody (misto uvedene vyjimky)
        throw new UnsupportedOperationException();
    }
    
    /*************************************************************************
     * Metoda na spocitani mzdovych nakladu.
     * Metoda projde vsechny osoby ve vstupnim souboru a secte hodnoty jejich
     * platu.
     */
    public double getWageCosts() {
        // sem doplnte kod metody (misto uvedene vyjimky)
        throw new UnsupportedOperationException();
    }
    
    /*************************************************************************/

    /**
     * Vytvori novou instanci teto tridy a nacte obsah
     * xml dokumentu se zadanym URL.
     */
    public static Uloha1 newInstance(URL url) throws DocumentException {
        return new Uloha1(url);
    }
    
    /**
     * Vytvori novou instanci teto tridy a nacte obsah
     * xml dokumentu ze zadaneho souboru.
     */
    public static Uloha1 newInstance(File file)
    throws DocumentException, MalformedURLException {
        
        return newInstance(file.toURL());
    }
    
    /**
     * Konstruktor, ktery vytvori novou instanci tridy Uloha1
     * nactenim obsahu xml dokumentu se zadanym URL.
     */
    private Uloha1(URL url) throws DocumentException {
        
        SAXReader xmlReader = new SAXReader(false);
        this.doc = xmlReader.read(url);
    }
    
    public void serializetoXML(OutputStream out, String aEncodingScheme)
    throws DocumentException, IOException {
        
        OutputFormat outformat = OutputFormat.createPrettyPrint();
        outformat.setEncoding(aEncodingScheme);
        XMLWriter writer = new XMLWriter(out, outformat);
        writer.write(this.doc);
        writer.flush();
    }
    
    public static void main(String[] args) throws DocumentException, IOException {
        
        if (args.length < 1) {
            System.err.println("Chybi argument se jmenem souboru pro " +
                    "zpracovani!");
            return;
        } else if (args.length < 2) {
            System.err.println("Chybi argument se jmenem vystupniho souboru!");
            return;
        }
        
        File input = new File(args[0]);
        File output = new File(args[1]);
        
        Uloha1 uloha1 = newInstance(input);
        
        System.out.println(uloha1.getWageCosts());
        
        uloha1.changeName("1", "Pavl\u00edk");
        uloha1.changeName("2", "Liborek");
        uloha1.adjustSalary(10000f);
        
        System.out.println(uloha1.getWageCosts());
        
        uloha1.serializetoXML(new FileOutputStream(output), "windows-1250");
    }
    
    /**
     * Help method for testing purposes.
     */
    Document getDocument() {
        return doc;
    }
}

