/*
 * Uloha1Test.java
 * JUnit based test
 *
 */

package uloha1;

import java.io.IOException;
import java.net.URL;
import java.util.List;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.dom4j.Document;

/**
 *
 * @author Petr Adamek
 */
public class Uloha1Test extends TestCase {
    
    public Uloha1Test(String testName) {
        super(testName);
    }
    
    Uloha1 uloha1;
    
    protected void setUp() throws Exception {
        URL url = Uloha1Test.class.getResource("people.xml");
        if (url == null) {
            throw new IOException("Nelze nalezt testovaci XML soubor");
        }
        uloha1 = Uloha1.newInstance(url);
    }

    public static Test suite() {
        TestSuite suite = new TestSuite(Uloha1Test.class);
        return suite;
    }

    /**
     * Test of adjustSalary method, of class uloha1.Uloha1.
     */
    public void testAdjustSalary() {
        float[] salaries = { 1000, 5000, 10000, 15000, 20000 };
        for (float salary : salaries) {
            uloha1.adjustSalary(salary);
            List peopleWithLessSalary = uloha1.getDocument().
                    selectNodes("//person[salary < " + salary + "]"); 
            
            assertTrue("Po volani metody adjustSalary s parametrem salary = " + 
                    salary + " stale existuji osoby s mensim platem",
                    peopleWithLessSalary.isEmpty());
        }
    }

    /**
     * Test of changeName method, of class uloha1.Uloha1.
     */
    public void testChangeName() {
        uloha1.changeName("1","Jindra");
        assertEquals("Jindra",uloha1.getDocument().
                selectSingleNode("//person[@id=1]/name").getText());
        uloha1.changeName("1","Pavel");
        assertEquals("Pavel",uloha1.getDocument().
                selectSingleNode("//person[@id=1]/name").getText());
        uloha1.changeName("2","Petr");
        assertEquals("Petr",uloha1.getDocument().
                selectSingleNode("//person[@id=2]/name").getText());
    }

    /**
     * Test of getWageCosts method, of class uloha1.Uloha1.
     */
    public void testGetWageCosts() {
        assertEquals(getWageCosts(uloha1.getDocument()),uloha1.getWageCosts());
        
        assertEquals(getWageCosts(uloha1.getDocument()),uloha1.getWageCosts());
    }

    private double getWageCosts(Document doc) {
        return Double.parseDouble(doc.selectObject("sum(//salary)").toString());
    }
}
